//
//  SessionNgaList.swift
//  Sailassist
//
//  Created by 三浦薫巳 on 2024/06/14.
//

import Foundation
import SwiftUI

class SessionNgaList : ObservableObject {
    @Published var status = false
    // シングルトン宣言
    static let OnlyOne = SessionNgaList()

    private var serverSession = ServerSession()
    private var Calling : Bool = false      // 通信中

    /**
     * タスクリスト取得
     */
    func RequestGetNgaList(_ completion: @escaping ((Result<Data, APIError>)) -> Void) {
        if Calling {
            return
        }
        Calling = true

        // リクエストURLの組み立て
        let id = Preferences.shipId
        if id != 0 {
            var url_string : String = HttpRequestType.NgaList.rawValue
            url_string = url_string.replacingOccurrences(of: "XXXXX", with: String(id))
            guard let req_url = URL(string : url_string) else {
                Calling = false
                return
            }

            serverSession.getJson(req_url, completion: completion)
        }
    }

    /**
     * タスク保存
     */
    func RequestPostNgaList(_ nga : ReqNgaList, completion: @escaping ((Result<Data, APIError>)) -> Void) {
        if Calling {
            return
        }
        Calling = true

        // リクエストURLの組み立て
        let id = Preferences.shipId
        if id != 0 {
            var url_string : String = HttpRequestType.NgaList.rawValue
            url_string = url_string.replacingOccurrences(of: "XXXXX", with: String(id))
            guard let req_url = URL(string : url_string) else {
                Calling = false
                return
            }

            if let postdata = serverSession.toJSON(nga) {
                serverSession.postJson(req_url, postdata, completion: completion)
            }
            else {
                Calling = false
                return
            }
        }
    }

    /**
     * NGAタスク削除
     */
    func RequestDeleteNgaList(_ ngaId : String, completion: @escaping ((Result<Data, APIError>)) -> Void) {
        print(debug: "calld")
        if Calling {
            return
        }
        Calling = true

        // リクエストURLの組み立て
        let id = Preferences.shipId
        if id != 0 {
            let strId = String(id) + "/" + ngaId
            var url_string : String = HttpRequestType.NgaList.rawValue
            url_string = url_string.replacingOccurrences(of: "XXXXX", with: strId)
            guard let req_url = URL(string : url_string) else {
                Calling = false
                return
            }

            serverSession.deleteJson(req_url, completion: completion)
        }
    }
}
